# ScriptsFromFile
C#通过文件执行lua脚本  
## 注意事项
AddSearchPath() —— 该函数：添加搜索路径，将 lua 与 .Cs 脚本的路径，添加至搜索范围  
***注意： 只有先添加了AddSearchPath()搜索路径，才可以保证以下2个函数的正常调用***   
DoFile() —— 该函数:执行 ScriptsFromFile.lua 脚本  
Require() —— 该函数：执行 引用 ScriptsFromFile lua 脚本
## 代码示例  
C#代码
```Csharp
using UnityEngine;
using LuaInterface;
/// <summary>
/// Chinar解释 —— tolua官方测试案例 2
/// 展示 searchpath 使用，require 与 dofile 区别
/// </summary>
public class ScriptsFromFile : MonoBehaviour
{
    LuaState lua = null;
    private string strLog = "";

    void Start()
    {
#if UNITY_5 || UNITY_2017 || UNITY_2018
        Application.logMessageReceived += Log;
#else
        Application.RegisterLogCallback(Log);
#endif
        lua = new LuaState();
        lua.Start();
        //如果移动了ToLua目录，自己手动修复吧，只是例子就不做配置了
        //string fullPath = Application.dataPath + "\\ToLua/Examples/02_ScriptsFromFile"; //这是官方默认路径，需要自己修改为自己的
        string fullPath = Application.dataPath + "\\LuaFramework/ToLua/Examples/02_ScriptsFromFile";
        lua.AddSearchPath(fullPath); //添加搜索路径，将lua与.Cs脚本的搜索路径，添加至搜索范围
    }

    void Log(string msg, string stackTrace, LogType type)
    {
        strLog += msg;
        strLog += "\r\n";
    }


    void OnGUI()
    {
        GUI.Label(new Rect(100, Screen.height / 2 - 100, 600, 400), strLog);

        if (GUI.Button(new Rect(50, 50, 120, 45), "DoFile")) //点击 DoFile 按钮
        {
            strLog = "";
            lua.DoFile("ScriptsFromFile.lua"); //执行 ScriptsFromFile.lua 脚本
        }
        else if (GUI.Button(new Rect(50, 150, 120, 45), "Require")) //点击 Requre 按钮
        {
            strLog = "";
            lua.Require("ScriptsFromFile"); //执行 引用 ScriptsFromFile 脚本
        }

        lua.Collect();  //收集GC
        lua.CheckTop(); //检验
    }

    /// <summary>
    /// 程序退出时
    /// </summary>
    void OnApplicationQuit()
    {
        lua.Dispose(); //释放
        lua = null;    //质空
#if UNITY_5 || UNITY_2017 || UNITY_2018
        Application.logMessageReceived -= Log;
#else
        Application.RegisterLogCallback(null);
#endif
    }
}
```
Lua代码
```Lua
print("This is a script from a utf8 file")
print("tolua: 你好! こんにちは! 안녕하세요!")
```
